/****************************************************************
* MNUTST.C - menu test frame, let user wander thru sample menus	*
****************************************************************/

#include <conio.h>		// getch(), kbhit()
#include <graph.h>		// _clearscreen(), _setbkcolor(), ...
#include <stdio.h>		// gets(), puts()
#include <stdlib.h>		// sprintf(), system()
#include "menu.h"		// colors, menu()

void SubMenu1(void), SubMenu2(void), doCommand(char *cmd);

/****************************************************************
* main - the main menu.  Allow entry to both menu tests.		*
****************************************************************/
#define EXIT	-1		// User selected 'EXIT' or ESC
#define MENU1	 1		// User selected the recursion menu
#define MENU2	 2		// User selected second test menu

MENU mnuMainMenu=
	{
	"The Cobb Group's Menu System"	DELIM
	"Main Menu",

	"1) First Submenu"		DELIM
	"2) Second Submenu"		DELIM
	"X) Exit to DOS",

	"1" DELIM "2" DELIM "x"  DELIM "X",

	"1" DELIM "2" DELIM "-1" DELIM "-1"
	};

void main(void)
	{
	for ( ; ; )
		switch (menu(&mnuMainMenu))
			{
			case MENU1:	SubMenu1();	break;
			case MENU2:	SubMenu2();	break;
			case EXIT:	_settextcolor(WHITE);
						_setbkcolor(BLACK);
						_clearscreen(_GCLEARSCREEN);
						exit(1);
						break;
			}
	}

/****************************************************************
* SubMenu1 - a test showing how deeply you can nest the menus	*
****************************************************************/
#define GO_DEEPER	1	// User is going down another level
MENU mnuSubMenu1=
	{
	"The Cobb Group's Menu System"	DELIM
	"Submenu 1"			DELIM
	""				DELIM
	"Since these menus are called in a recursive function" DELIM
	"You may keep 'going down' until you run out of RAM, " DELIM
	"or you get tired.  You will then have to select EXIT" DELIM
	"the same number of times to return to the Main Menu",

	"D) Go down deeper"			DELIM
	"X) Return to calling menu",

	"d" DELIM "D" DELIM "x"  DELIM "X",

	"1" DELIM "1" DELIM "-1" DELIM "-1"
	};

void SubMenu1(void)
	{
	for ( ; ; )
		switch (menu(&mnuSubMenu1))
			{
			case GO_DEEPER:	SubMenu1();	break;
			case EXIT:		return;
			}
	}

/****************************************************************
* SubMenu2 - a simple menu that allows the user to choose from	*
* several simple actions, and performs the action indicated.	*
****************************************************************/
MENU mnuSubMenu2=
	{
	"The Cobb Group's Menu System"	DELIM
	"Submenu 2",

	"1) CHKDSK"		DELIM
	"2) COMMAND"	DELIM
	"3) DIR"		DELIM
	"4) EDLIN"		DELIM
	"X) Exit",

	"1" DELIM "2" DELIM "3" DELIM "4" DELIM
	"X" DELIM "x",

	"1" DELIM "2" DELIM "3" DELIM "4" DELIM
	"-1" DELIM "-1"
	};

#define cmdCHKDSK	1		// User wants to check the disk
#define cmdCOMMAND	2		// User wants to shell out to DOS
#define cmdDIR		3		// User wants a list of files
#define cmdEDLIN	4		// User wants to edit a file

void SubMenu2(void)
	{
	char tmp1[50],tmp2[60];
	static int tone=440;
	for ( ; ; )
		switch (menu(&mnuSubMenu2))
			{
			case cmdCHKDSK:		doCommand("chkdsk");	break;
			case cmdCOMMAND:	doCommand("command");	break;
			case cmdDIR:		doCommand("dir /p");	break;
			case cmdEDLIN:		_setbkcolor(BLACK);
								_clearscreen(_GCLEARSCREEN);
								puts("Edit what file?");
								gets(tmp1);
								sprintf(tmp2,"edlin %s",tmp1);
								doCommand(tmp2);		break;
			case EXIT:			return;
			}
	}

/****************************************************************
* doCommand - perform the specified command						*
****************************************************************/
void doCommand(char *cmd)
	{
	_setbkcolor(BLACK);
	_clearscreen(_GCLEARSCREEN);
	printf("*** Performing command: %s ***\n",cmd);
	puts("If you are executing COMMAND, type EXIT to quit\n");
	system(cmd);
	puts("\nPress any key to return to menu");
	while (!kbhit())
		;
	getch();
	}
