/****************************************************************
* MTCOPY2.C - replacement main function that allows multiple	*
* simultaneous copies											*
****************************************************************/

void main(int argc, char **argv)
    {
    void *cp[4];
    int i;

    if(argc < 3 || argc > 9)
        error_exit(0,"Usage: MTCOPY "
            "<source> <dest> "
            "[<s2> <d2>] [<s3> <d3>] "
            "[<s4> <d4>]\n");

    for( i = 0, argc--; i < (argc/2); i++)
        {
        mtcopy_init(&cp[i],strupr(argv[(i*2)+1]),
        			strupr(argv[(i*2)+2]));
        mtcopy(cp[i]);
        }

    // substitute some other part of an application
    // here.  Copy is done by other threads

    while(TRUE)
        {
        for(i = 0; i < (argc/2); i++)
            if(cp[i] != NULL)
                if(mtcopy_finished(cp[i]))
                    {
                    printf("copy #%d complete\n",i+1);
                    free(cp[i]);
                    cp[i] = NULL;
                    }

        for(i = 0; i < (argc/2); i++)
            if(cp[i] != NULL)
                break;
        if(i >= (argc/2))
            {
            printf("All copying is complete, terminating\n");
            break;
            }
        }
    DosExit(0,EXIT_PROCESS);
    }
